//gW 2009-02-27   'View'

	/*  viewitem = *(viewtyp ":" viewvalue *("," viewvalue) ;)
	 *     
	 *		viewtyp = *("SUMMARY" / "CATEGORIES" / "NOTES" / "LOCATION" / "DATE") 
	 *			Note:  "DESCRIPTION" has to be replaced with "summary" 
	 *             
	 *		'viewtyp' MAY occur more than once;
	 * 	for each 'viewtyp' one 'viewvalue' MUST occur at least once, 
	 *		but MAY occur more than once
	 * 
	 *		For each reminder the items are checked against the 'viewitem'. 
	 * 	If the condition is met, the reminder is included in the 'View' list.
	 * 	 
	 *    For 'viewtyp' = "DATE"  valid entries to 'viewvalue' are:
	 * 		'viewvalue' = *('TODAY'/'CURRENT_WEEK'/'NEXT_WEEK'/'NEXT_2WEEKS'/'CURRENT_MONTH' ),
	 * 		the reminder date has to fall within the 'viewvalue' range; all date ranges
	 *			are related to 'today'.
	 * 
	 *		For 'viewtype' = *("SUMMARY" / "CATEGORIES" / "NOTES" / "LOCATION")
	 * 		the 'viewvalue' string MUST exsist in the reminder item.
	 * 	
	 * 		'viewvalue' with leading '#' character will invert the condition
	 * 			the 'viewvalue' string MUST NOT exsist in the reminder item.		
	 *
	 * 	Multiple 'viewvalue' for one 'viewtyp' are handled as 'OR' connected,
	 * 	multiple 'viewtyp' for one 'viewitem' are handled as 'AND' function.
	 * 	
	 *  		Example:  "DESCRIPTION:Mail,Send;CATEGORIES:business;categories:projectA;"
	 * 	 		read:  'mail' OR 'send' in 'DESCRIPTION' AND CATEGORIES='business' AND CATEGORIES='projectA'
	 *             	
	 *  	'Criteria' descriptors 
	 * 		The 'viewtyp' (called 'Criteria' at UI level) is stored to a preference:
	 * 			'extensions.reminderFox.views'
	 * 		with 'general' descriptors. At the UI those descriptors have 'local'
	 * 		equivalent stored with "reminderFox-bundle" / reminderfox.properties.
	 * 
	 * 		Example:  general: "LOCATION:Hamburg", local: "Ort:Hambug" 
	 **/
	 
	// strings to hold 'locale' descriptors for 'Criteria' and 'Date'
	var 	rmFxViewLocalDesc	= reminderFox_getBundle().getString("rf.html.heading.description");
	var  	rmFxViewLocalCat	= reminderFox_getBundle().getString("rf.add.reminders.tooltip.categories");
	var  	rmFxViewLocalNotes= reminderFox_getBundle().getString("rf.add.mail.message.notes");
	var  	rmFxViewLocalLoc	= reminderFox_getBundle().getString("rf.add.reminders.tooltip.locaton");
	var 	rmFxViewLocalDate	= reminderFox_getBundle().getString("rf.html.heading.date");

	var 	rmFxViewToday		= reminderFox_getBundle().getString("rf.views.heute"); 			// "Heute"				"TODAY"
	var 	rmFxViewCurWeek	= reminderFox_getBundle().getString("rf.views.currentweek"); 		// "Diese Woche"		"CURRENT_WEEK"
	var 	rmFxViewNextWeek	= reminderFox_getBundle().getString("rf.views.nextweek.label"); // "Nächste Woche"	"NEXT_WEEK"
	var 	rmFxViewNext2Weeks= reminderFox_getBundle().getString("rf.views.next2weeks"); 		// "2Wochen"			"NEXT_2WEEKS"
	var 	rmFxViewCurMonth	= reminderFox_getBundle().getString("rf.views.currentmonth");	// "Dieser Monat"		"CURRENT_MONTH"

	var rmFxViewPrefs;
	var rmFxViews ;
	var rmFxViewItems ="";
	var rmFxViewLabel ="";

//	 var isImportant = reminder.priority == REMINDER_PRIORITY_IMPORTANT;
//	 var isCompleted = reminderFox_isCompletedForDate( reminder, reminder.date);


// === main function to pre-select reminder based of 'VIEW' selection === 
function rmFx_ViewThis(reminder) {
 
	if (rmFxViewItems != "") {			
		var statusAll = true;
		var viewArray = rmFxViewItems.split(";")
		for (var i=0; i < viewArray.length ; i++) {
			
			var statusClass = true;
			var viewvalueInvert = false;	// for checking "NOT" included string
 
			var nPos = viewArray[i].indexOf(":");
			var viewtyp = viewArray[i].substring(0,nPos);
			var viewvalue = viewArray[i].substring(nPos+1,(viewArray[i]).length);

			if ((viewtyp != null) || (viewtyp != "")) {
				var viewtyp = viewtyp.toLowerCase();
				
				var statusDetail = false;
				var viewdetail = viewvalue.split(",")
				for (var j1=0; j1 < viewdetail.length ; j1++) {
					var cViewDetail = viewdetail[j1];
					if (cViewDetail[0] == "#") {
						viewvalueInvert = true;
						cViewDetail = cViewDetail.substring(1,viewvalue.length)
					}

					try {		//  skip for invalid 'Item' description  
						if (viewtyp == 'date') {
							//  (" check the 'date' value of reminder");
							statusDetail = rmFx_View.DateValid(reminder, cViewDetail);
							
						} else {		//  (" check string values");
							if (viewvalueInvert == true) {
							// set flag if cViewDetail NOT included
								if (reminder[viewtyp] == null) {statusDetail = true;}
								
								if (reminder[viewtyp].toLowerCase().indexOf(cViewDetail.toLowerCase()) == -1){
									statusDetail = true;
								}
							} else {
							// set flag if cViewDetail IS  included
								if (reminder[viewtyp] == null) {statusDetail = false;
								} else { 
													
									if (reminder[viewtyp].toLowerCase().indexOf(cViewDetail.toLowerCase()) != -1){
										statusDetail = true;
									}	
								}
							} 
						}	
					} catch (e) {
						var xx=0;}
				}
				statusClass = statusClass & statusDetail;
			}
		statusAll = statusAll & statusClass;
		
		}		
	}	
	return statusAll;
}
//////////////////////////////////////////////////////////////////////

function rmFx_View () {   // --- 'View' support functions ---
}


rmFx_View.LoadCurrentPref = function () {

	// extensions.reminderFox.viewcurrent = send=<SUMMARY:send;>,
	// rmFxUtil.dump2Console ("loadReminders RemTab:" + isReminderTabSelected());

	rmFxViewItems = "";
	rmFxViewLabel = "";
	var rmFxViewString = "";
	try {
		rmFxViewString = reminderFox_getUnicodePref(REMINDER_FOX_PREF + "." + "viewcurrent");
	} catch(e) {}
	
	if (rmFxViewString != "") {
		rmFxViewLabel = rmFxViewString.split("=<")[0];
		rmFxViewItems = rmFxViewString.split("=<")[1].split(";>")[0]
	}	
}


rmFx_View.DateValid = function (reminder, searchFor) {
	// --- searchFor : see 'addReimderDialog.js  at function getStartAndEndDates

	var newDate = new Date();
	var dateType = 0;
	
	switch (searchFor.toUpperCase()) {
		case 'TODAY':			{dateType = 3; break;}
		case 'CURRENT_WEEK':	{dateType = 2; break;}
		case 'NEXT_WEEK':		{dateType = 4; break;}
		case 'NEXT_2WEEKS':		{dateType = 5; break;}
		case 'CURRENT_MONTH':	{dateType = 1; break;}
	}	
	
	// use 'addReminderDialog' function	 to get the dates 
	var theseDates = getStartAndEndDates(dateType, true);
	// alert ("getStartAndEndDates " + theseDates.start +  "  " + theseDates.end + " dateType:" + dateType);
	
	var limitWeeklyReminders = false;	
	var reminders = reminderFox_getAllRemindersInDateRange( reminder, theseDates.start, theseDates.end, limitWeeklyReminders )
	return (reminders.length > 0) ? true : false;	
}

rmFx_View.Clone = function () {	// called from addReminderDialog.js
	// --- call with tab-change to change child ---
	var rmViewHbox = document.getElementById('rmViewHbox');
	if ( isReminderTabSelected() ) { /* --- Reminders selected --- */	
			var clonedBox = rmViewHbox.cloneNode( true );
			rmViewHbox.parentNode.removeChild( rmViewHbox );
			document.getElementById("rmView_Box").appendChild( clonedBox );
	} else {  /* ---	Todos oder user-Lists selected 	--- */
		/*   load XUL new */
			var clonedBox = rmViewHbox.cloneNode( true );
			rmViewHbox.parentNode.removeChild( rmViewHbox );
			document.getElementById("todoView_Box").appendChild(clonedBox);
	}
}


rmFx_View.CriteriaExchange = function (criteria) {
		// exchange  'local' and 'general' criteria descriptors 
		//  mode ==  'local'  or 'general' 
		
		var xCriteria = criteria.split(";");
		for (var j=0; j < xCriteria.length; j++) {
			
			var nPos = xCriteria[j].indexOf(":");
			var xx = xCriteria[j].substring(nPos+1,xCriteria[j].length);
			
		//	var xx = xCriteria[j].split(":")[1];

			if (xCriteria[j].split(":")[0] == "DATE") {
				xx = rmFx_View.CriteriaExchangeGo(xx)
			} 

			xCriteria[j] = rmFx_View.CriteriaExchangeGo(xCriteria[j].split(":")[0]) 
					+ ":" + xx;
		} 
		return xCriteria.join(";");
}

		rmFx_View.CriteriaExchangeGo = function (criteria) {
			switch (criteria) {
				case "SUMMARY": 			{return  rmFxViewLocalDesc; }
				case "CATEGORIES": 			{return  rmFxViewLocalCat; }
				case "LOCATION": 			{return  rmFxViewLocalLoc; }
				case "NOTES": 				{return  rmFxViewLocalNotes; }
				case "DATE": 				{return  rmFxViewLocalDate; }

				case "TODAY": 				{return	rmFxViewToday;}
				case "CURRENT_WEEK":  		{return	rmFxViewCurWeek;}
				case "NEXT_WEEK":  			{return	rmFxViewNextWeek;}
				case "NEXT_2WEEKS":  		{return	rmFxViewNext2Weeks;}
				case "CURRENT_MONTH":  		{return	rmFxViewCurMonth;}
			}		
			return criteria;	// nothing matched, so return original criteria value
		}


rmFx_View.criteriaTypChanged = function (event){
	
	if (event.target.attributes["label0"].value =="DATE") {
		// ("DATE");
		document.getElementById('criteria_Box').setAttribute('hidden', true);	
		document.getElementById('criteria_Date').setAttribute('hidden', false);
		document.getElementById('criteria_Date').selectedIndex=0;		
	} else {
		// ("STRING (non DATE)");
		document.getElementById('criteria_Box').setAttribute('hidden', false);	
		document.getElementById('criteria_Date').setAttribute('hidden', true);		
	}
}

rmFx_View.MenuItems = function (xList, Label, Label0) {
			var m1 = document.createElement("menuitem");
			m1.setAttribute("label", Label);
			m1.setAttribute("label0", Label0);
			xList.appendChild(m1);
}


/////// VIEW - EDITOR ////////////////////////////////////////////////////
// ==== part 1 -- pulldown menu with "addreminder-dialog.xul" ============

function rmFx_ViewSelect(thisLabel) {
// ("--- called by pull-down 'View' .. to be used to build the menu from prefs");

	var exportView="";

	try  {
		var rmFxViewPrefs = reminderFox_getUnicodePref(REMINDER_FOX_PREF + "." + "views");
	} catch (e) { }
	
	var mList = document.getElementById('view-menupopup');

	/* delete all 'View' items only */
	var count = mList.childNodes.length;
	
	while ( count-- ) {
		var child = mList.childNodes[count];	
		if (count != 0) {		// count == 0 is the first entry, the "No View"
			mList.removeChild(mList.childNodes[count]);
		}
	}
	var m1 = document.createElement("menuseparator");
	(mList.appendChild(m1));

	if ((rmFxViewPrefs != null) && (rmFxViewPrefs != "")) {

		rmFxViews = rmFxViewPrefs.split(";>,")

		var vCount = rmFxViews.length; 
	
		while ( vCount -- ) {
			var m1 = document.createElement("menuitem");
			
			var newItemA = rmFxViews[vCount].split("=<");
			
			if (newItemA[0].length > 0) {
				try {
					m1.setAttribute("type" , "checkbox");
					m1.setAttribute("oncommand", "rmFx_ViewSet(this);");
					
					m1.setAttribute("label", newItemA[0]);		
					m1.setAttribute("value", newItemA[1]);
					
					// tooltiptext  displays the 'value' of this 'View'
					// need to change from 'general' to 'local' Criteria
					m1.setAttribute("tooltiptext", rmFx_View.CriteriaExchange(newItemA[1]));

					if (newItemA[0].toLowerCase() == rmFxViewLabel.toLowerCase()) {
							m1.setAttribute("checked",true);
							exportView = newItemA[0];
					}
					(mList.insertBefore(m1,mList.childNodes[2])); // after node 1 (menuseparator)
				} catch (e) {
					alert ("VIEW: here we have a problem to add an item!")
				}
			}
		}
		var m1 = document.createElement("menuseparator");
		(mList.appendChild(m1));
	}	
	
	var m1 = document.createElement("menuitem");
	m1.setAttribute("oncommand", "rmFx_ViewManage(this);");
	m1.setAttribute("label", 
		reminderFox_getBundle().getString("rf.views.ttt.editor"));
	m1.setAttribute("value", "");
	m1.setAttribute("tooltiptext",
		reminderFox_getBundle().getString("rf.views.ttt.edit")); 
	//	"Edit 'View's"
	
		(mList.appendChild(m1));
		
	if (exportView != "") {	
		var m1 = document.createElement("menuseparator");
		(mList.appendChild(m1));

		var m1 = document.createElement("menuitem");
		m1.setAttribute("oncommand", "rmFx_ExportCurrentView(this);");
		m1.setAttribute("label", 
				reminderFox_getBundle().getString("rf.views.editor.exportSend") 
				+ " [" + exportView + "]");
		m1.setAttribute("value", "");
		m1.setAttribute("tooltiptext", 
				reminderFox_getBundle().getString("rf.views.ttt.editor.exportSend")); 
			
		(mList.appendChild(m1));
	}
}


// ==== part 2 -- select a 'View'  =============

function rmFx_ViewSet(thisLabel) {
// ("--- to set the 'View' with  pull-down");
	
	rmFxViewLabel = thisLabel.label;
	rmFxViewItems = thisLabel.value;
	
	rmFx_ViewSetTitel(rmFxViewLabel, rmFxViewItems);

	refillLists();
}

function rmFx_ViewSetTitel(rmFxViewLabel, rmFxViewItems) {
	var rmFxTitel = reminderFox_getBundle().getString("rf.title");  //use .properties 

	if (rmFxViewItems == "") {  // 	no 'View' 
		document.getElementById("view_Selection").setAttribute("status", "off");
		document.getElementById("view_Selection").setAttribute("tooltiptext", 
			reminderFox_getBundle().getString("rf.views.ttt.editor"));  //	"Configure 'View'"
		document.title = rmFxTitel + "";  //" .. ";

		//ViewCurrent
		reminderFox_setUnicodePref("viewcurrent", "");	
	} else {							 // 	a 'View' was selected
		document.getElementById("view_Selection").setAttribute("status", "on");
		document.getElementById("view_Selection").setAttribute("tooltiptext", rmFxViewItems);		
		document.title = rmFxTitel + "    " + reminderFox_getBundle().getString("rf.views.name")
				+ ": [" + rmFxViewLabel + "]";
		//ViewCurrent
		reminderFox_setUnicodePref("viewcurrent", rmFxViewLabel + "=<" + rmFxViewItems + ";>,");
	}
	//  rmFx_View4tabs(rmFxViewLabel, rmFxViewItems);  //  test ++++    test ++++    test ++++   
}


//gW test ++++    test ++++    test ++++    test ++++    test ++++    test ++++   
function rmFx_View4tabs(rmFxViewLabel, rmFxViewItems) {		//gW +++2do +++2do +++2do +++2do +++2do +++2do +++2do 
	//	rmFxUtil.dump2Console ("***** selectTab RemTab:" + isReminderTabSelected());
	
		// reminders:new,ToDo's:sendTest,Geburtstage:dieserMonat
	
	/*   store 'View' pro TAB
	 *
 	 *	viewcurrent= (tabname ":" viewlabel) *(,tabname ":" viewlabel)
	 *  
	 * 	Bei jedem Aufruf pr�fen ob alle tabs noch vorhanden, gel�schte auch hier
	 *		aus dem String entfernen
	 * 
	 */
	 
	// extensions.reminderFox.todoLists = followup,ToDo's    'reminders' not stored tp prefs 
	
	var namesTabs = reminderFox_getPreferenceValue( REMINDER_FOX_TODO_LISTS )
			+ ",Reminders,ToDo's";
	var nameList = namesTabs.split(",");

	
	var viewCurrentArray = new Array(); 

	try {
		var viewCurrent = reminderFox_getUnicodePref(REMINDER_FOX_PREF + "." + "viewcurrent1");
		if (viewCurrent != "") viewCurrentArray = viewCurrent.split(",");
	} catch(e) {}	
	
	var tabSelected =	document.getElementById("tabList").selectedItem.label;

	var newViewList = new Array();
	
  	for ( var n in viewCurrentArray ) {

  		var current = viewCurrentArray[n];
  		
  		if (current.indexOf(':') != -1) {
			var currentTab = current.split(':')[0];
 			var currentView = current.split(':')[1];
  		}  else {
  			// this entry is without the 'tab' ... have to migrate
  			// and use it as 'Reminders'
			var currentTab = 'Reminders';
 			var currentView = current;
  		}
  		
  		if (currentTab != tabSelected)		/*  selected tab */
  	/*		&& (rmFxViewItems != "")	*/		/*  'No View' selected */
  		{ 
  			newViewList[newViewList.length] = currentTab + ":" + currentView;	
  		}
  	}
  	if (rmFxViewItems != "") {
		newViewList[newViewList.length] = tabSelected + ":" + rmFxViewLabel;	
  	}
  	var newViewDef = newViewList.join(',');
 
	reminderFox_setUnicodePref("viewcurrent1", newViewDef);
	
}
// test ++++    test ++++    test ++++    test ++++    test ++++    test ++++   




// === part 3 -- Manage the 'View's  =============
	
function rmFx_ViewManage() {
// ("--- calls 'rmFx_ViewLoad()' to load the defined 'View's from the pref ---")
	window.openDialog("chrome://reminderfox/content/categories/rmFxViewEditor.xul",
			"rmFx_ViewManageDialog", "chrome,resizable,modal" );
}

function rmFx_ViewManageLoad() {
// (" --- build the <menupopup id='criteria_Labels'> from .prop entires");
// 	'value'  is used to work on internal string as stored with the .views prefs

		/* delete all 'Criteria' items  */
		var cList = document.getElementById('criteria_Labels');
		var count = cList.childNodes.length;
		
		while ( count-- ) {
			cList.removeChild(cList.childNodes[count]);
		}
		// add menuitems from .prop to ensure we use the same with XUL and js 
		rmFx_View.MenuItems (cList, rmFxViewLocalDesc, 	"SUMMARY");
		rmFx_View.MenuItems (cList, rmFxViewLocalCat, 	"CATEGORIES");
		rmFx_View.MenuItems (cList, rmFxViewLocalNotes, "NOTES");
		rmFx_View.MenuItems (cList, rmFxViewLocalLoc, 	"LOCATION");
		rmFx_View.MenuItems (cList, rmFxViewLocalDate, 	"DATE");

		/* delete all 'criteria_Date' items  */
		var cList = document.getElementById('criteria_DateItems');
		var count = cList.childNodes.length;
		
		while ( count-- ) {
			cList.removeChild(cList.childNodes[count]);
		}
		// add menuitems from .prop to ensure we use the same with XUL and js 
		rmFx_View.MenuItems (cList, rmFxViewToday,		"TODAY");
		rmFx_View.MenuItems (cList, rmFxViewCurWeek, 	"CURRENT_WEEK");
		rmFx_View.MenuItems (cList, rmFxViewNextWeek,	"NEXT_WEEK");
		rmFx_View.MenuItems (cList, rmFxViewNext2Weeks,	"NEXT_2WEEKS");
		rmFx_View.MenuItems (cList, rmFxViewCurMonth,	"CURRENT_MONTH");

	// ("--- load the 'View's ---"); 
	try { // gW UnicodePref
		rmFxViewPrefs = reminderFox_getUnicodePref(REMINDER_FOX_PREF + "." + "views"); 
		rmFxViews = rmFxViewPrefs.split(";>,")
				
		var viewList = document.getElementById('view_List');

		var vCount = rmFxViews.length;
		while ( vCount -- ) {
			var m1 = document.createElement("listitem");
			// apply parameters & insert before node 0
			if (rmFxViews[vCount] != "") {
				
				var xx =rmFxViews[vCount].split("=<");	// ex: FoxInfo=<"DATE:TODAY;>,
				m1.setAttribute("label", xx[0]);		// FoxInfo
				m1.setAttribute("value", xx[1]);		// DATE:TODAY	

				m1.setAttribute("oncommand", "rmFx_ViewFocus(this);");
				m1.setAttribute("tooltiptext", 
					reminderFox_getBundle().getString("rf.views.ttt.view"));

				if ( viewList.childNodes.length == 0 ) {
					 viewList.insertBefore(m1,null);
				}
				else {
					viewList.insertBefore(m1,viewList.childNodes[0]);
				}
			}
		}
	} catch (s) {};
	rmFx_ViewButtons.Start(true);
}

function rmFx_ViewFocus(mode) {
// ("--- FOCUS for  'View' ---");				// example 
	var vLabel = mode.currentItem.label;		// FoxInfo
	var vValue = mode.currentItem.value;		// DATE:TODAY
	
	var detailsBox = document.getElementById('criteria_List');
	var count = detailsBox.childNodes.length;
	while ( count-- ) {
			detailsBox.removeChild(detailsBox.childNodes[count])
	}
	var xx = vValue.split(";")	
	for (var i=0; i<xx.length; i++){	
		var m1 = document.createElement("listitem");	
			
		// change from 'general' to 'local' Criteria descriptors
		m1.setAttribute("label", rmFx_View.CriteriaExchange(xx[i]));
		m1.setAttribute("label0", xx[i]);		// save the original value 
		m1.setAttribute("tooltiptext", 
					reminderFox_getBundle().getString("rf.views.ttt.criteria"));

		detailsBox.appendChild(m1);
	}
	rmFx_ViewButtons.Start(false);
}

function rmFx_ViewAdd(mode) {
	var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                  .getService(Components.interfaces.nsIPromptService);

	var newText = reminderFox_getBundle().getString("rf.views.new");
	var titel = reminderFox_getBundle().getString("rf.views.newView");
	var instruct = reminderFox_getBundle().getString("rf.views.enterName");
	
	var check = {value: false};      // default the checkbox to false
	var input = {value: newText};    // default the edit field to 'new'

	if (prompts.prompt(null, titel, instruct, input, null, check) == false) {return;};
	
	// OK pressed, input.value holds the value

	rmFxViewChanged = true;
	
	// add this new 'View' ... don't allow ':' or ',' in name of viewList
	var viewList = document.getElementById('view_List');
	if (input.value.search(/(:|\,)/g) != -1) {
		statusMsg = reminderFox_getBundle().getString("rf.views.ttt.notodos"); //"Do not use ':' or ',' here."
		rmFxCore.statusSet (statusMsg);
		return;}	// not allowed

	var m1 = document.createElement("listitem");	
	m1.setAttribute("label", input.value);
	m1.setAttribute("value", "SUMMARY:??");
	m1.setAttribute("tooltiptext", 
		reminderFox_getBundle().getString("rf.views.ttt.view"));	//	"Select a 'View' to edit 'criteria'"
	viewList.appendChild(m1);
	
	viewList.selectedIndex = viewList.childNodes.length -1;
		
	// add to Criteria_List   'SUMMARY:??'  
	var listBox = document.getElementById('criteria_List');
	var count = listBox.childNodes.length;
	while ( count-- ) {
			listBox.removeChild(listBox.childNodes[count])
	}
		var m1 = document.createElement("listitem");	
			
		// change from 'general' to 'local' Criteria descriptors
		m1.setAttribute("label", (rmFxViewLocalDesc + ":??"));
		m1.setAttribute("label0", "SUMMARY:??");
		m1.setAttribute("tooltiptext", 
					reminderFox_getBundle().getString("rf.views.ttt.criteria"));

		listBox.appendChild(m1);
		
		sizeToContent();
}

function rmFx_ViewRemove(mode) {
// ("---  REMOVE a  View ---" );

	var viewList = document.getElementById('view_List');
	var i = viewList.selectedIndex
	if (i == -1) {return};
	
	var viewLabel = viewList.childNodes[i].label

 	// prompt the user before Deleting
	var title =	reminderFox_getBundle().getString("rf.views.ttt.viewremoveTitel");
	var msg =	reminderFox_getBundle().getString("rf.views.ttt.viewremove1")
					+ "  >" + viewLabel + "<  " 
					+ reminderFox_getBundle().getString("rf.views.ttt.viewremove2");
	var key0 =	reminderFox_getBundle().getString("rf.button.ok");
	var key1 =	reminderFox_getBundle().getString("rf.button.cancel");	
	
	if (rmFxUtil.ConfirmEx(title, msg, key0, key1) == 1 ) {  // cancel pressed
			return;
	}			
	// buttonPressed  OK ... delete

	rmFxViewChanged = true;
	
	var detailsBox = document.getElementById('criteria_List');
	var count = detailsBox.childNodes.length;
	while ( count-- ) {
			detailsBox.removeChild(detailsBox.childNodes[count])
	}
	viewList.removeChild(viewList.childNodes[i])
	
	rmFx_ViewButtons.Start(true);
}


// === part 4 -- manage Criteria ====================

function rmFx_CriteriaShow(mode) {
// ("---  show Criteria in edit box ---");
	if (mode.selectedIndex == -1 ) {return};
	
	// var thisCritera = mode.selectedItem.label.split(":"); // ex:  Datum:Heute

	var criteriaString = mode.selectedItem.label;
	var nPos = criteriaString.indexOf(":");
	var thisCritera = criteriaString.substring(0,nPos);
	var thisValue = criteriaString.substring(nPos+1,criteriaString.length);

	var criteraTyps = document.getElementById('criteria_Typs');	
	// select the menu item from pulldownmenu 
	for (var i=0; i < criteraTyps.childNodes[0].childNodes.length; i++ ) { 
		if (thisCritera.toLowerCase() == criteraTyps.childNodes[0].childNodes[i].label.toLowerCase()) {
				criteraTyps.selectedIndex = i;
		}
	}
	
	// setup 'criteria_Box' for 'textbox'(strings) or 'pulldnmenu'(for DATE)
	rmFx_ViewButtons.CriteriaString(thisValue, 
		mode.selectedItem.attributes["label0"].value.split(":")[0]== "DATE" ?
			thisValue : 	"");
// OKbutton
	document.getElementById('OK').setAttribute("disabled","true");	
}

var rmFxViewChanged = false;

function rmFx_ViewCriteriaEnter() {
// ("-- read the 'criteria_Box' string and replace/add to 'criteria_List' ---");

	var ivList = document.getElementById('view_List').selectedIndex;

	var typLabel = document.getElementById('criteria_Typs').selectedItem.attributes["label0"].value  // "DATE

	var typ  = document.getElementById('criteria_Typs').label
	var typ0 = document.getElementById('criteria_Typs').selectedItem.attributes['label0'].value

	if (typLabel != "DATE") {  	// string op

		if (document.getElementById('criteria_Box').value != "" ) {
			rmFxViewChanged = true;
						
			var newCriteria  = typ  + ":" + document.getElementById('criteria_Box').value;	// "Notiz:xxyyxx"
			var newCriteria0 = typ0 + ":" + document.getElementById('criteria_Box').value;	// "NOTES:xxyyxx"
		}
	} else {								// "DATE" op
			rmFxViewChanged = true;
			
			var newCriteria = typ + ":"
					+ document.getElementById('criteria_Date').selectedItem.label;  /// "Datum:Dieser Monat"
			var newCriteria0 = typ0 + ":"
					+ document.getElementById('criteria_Date').selectedItem.attributes["label0"].value; // "DATE:CURRENT_MONTH"
	}

	if (rmFxViewChanged) {
			var criteriaList = null;  // reset var
			var criteriaList = document.getElementById('criteria_List');
			var icList = criteriaList.selectedIndex;
	
			var m1 = document.createElement("listitem");	
			m1.setAttribute("label", newCriteria);		// 'local'
			m1.setAttribute("label0", newCriteria0);	// 'general'
			m1.setAttribute("tooltiptext", 
				reminderFox_getBundle().getString("rf.views.ttt.criteria"));
	//			"Select a 'Criteria' to edit"
		
			if (icList == -1) { // this is a ADD 			
				criteriaList.appendChild(m1);
				
				var xCount = criteriaList.childNodes.length
				if ((xCount == 2) && (criteriaList.childNodes[0].label == "")) {
					criteriaList.removeItemAt(0);
					criteriaList.selectedIndex =0;
				}
			} else {       // replace the current item
				var oldNode = criteriaList.childNodes[icList];
				criteriaList.replaceChild(m1, oldNode);
			}  
			// now change the 'value' of the 'View'
			for (var i=0; i < criteriaList.childNodes.length; i++) {
				if (i==0) {
					var criteriaListNew = criteriaList.childNodes[0].attributes["label0"].value
				} else {
					criteriaListNew += ";" + criteriaList.childNodes[i].attributes["label0"].value
				}
			}
			document.getElementById('view_List').childNodes[ivList].value = criteriaListNew
		}	
	rmFx_ViewButtons.CriteriaEnter();
}


function rmFx_ViewCriteriaAdd(mode) {
// ("---  add a new Criteria to a 'View' ---");
	var m1 = document.getElementById("criteria_List");	
	m1.clearSelection();

	rmFx_ViewButtons.CriteriaAdd();
}


function rmFx_ViewCriteriaRemove() {
// ("---  REMOVE a 'Criteria' from a 'View' ---");
	var aa= document.getElementById('criteria_List')
	try {
		aa.removeChild(aa.childNodes[aa.selectedIndex])
		document.getElementById('criteria_Box').value = "";
		
	// now change the 'value'
		var criteriaListNew ="";
		for (var i=0; i < aa.childNodes.length; i++) {
			if (i==0) {
				var criteriaListNew =aa.childNodes[0].label;
			} else {
				criteriaListNew += ";" + aa.childNodes[i].label;
			}
		}
		i = document.getElementById('view_List').selectedIndex
		document.getElementById('view_List').childNodes[i].value = criteriaListNew
	
		rmFxViewChanged = true;
	} catch (e) {}
	rmFx_ViewButtons.CriteriaEnter();
}


function rmFx_ViewSaveAndClose(mode) {

	if (rmFxViewChanged == false) {window.close(); return};

	var title = reminderFox_getBundle().getString("rf.views.closeTitel");	//'View' Editor - Closing";
	var msg   = reminderFox_getBundle().getString("rf.views.closeWarning");
	var key0  = reminderFox_getBundle().getString("rf.views.discard");		//YES, discard";
	var key1  = reminderFox_getBundle().getString("rf.views.noGoBack");		//NO, go back to Editor";
	var key1s  = reminderFox_getBundle().getString("rf.views.noSave");		//NO, save";

	if (mode == 'CANCEL') {  
		// ("--- rmFx_ViewSaveAndClose w 'CANCEL'---");

		if (rmFxUtil.ConfirmEx(title, msg, key0, key1) == 1 ) {
			return;  // 'No' pressed .. return to XUL
		}			
		// buttonPressed  'OK' ... discard all changes!!
		window.close();
		return;
	}
	
	if (mode == 'X') {  // 
		// ("--- the window 'X' at the header was used .. now handle the edited 'prefs' ---");
		if (rmFxUtil.ConfirmEx(title, msg, key0, key1s) == 0 ) { 
			return;  // buttonPressed  'OK' ... delete
		}			
		// 'NO, save'  pressed, go for save
	}
	// ("--- Views/Criteria will be saved to 'prefs' ---");
	var viewList = document.getElementById('view_List');
	var n = viewList.childNodes.length;

	rmFx_View.LoadCurrentPref(); 

	var cView = rmFxViewLabel;
	
	var rmFxViewPrefs = "";
	for (var i=0; i< viewList.childNodes.length; i++) {
		var newEntry = viewList.childNodes[i].label
		 			+ "=<" + viewList.childNodes[i].value + ";>,";

		rmFxViewPrefs += newEntry;
		 			
		if (viewList.childNodes[i].label == cView) {
			reminderFox_setUnicodePref("viewcurrent", newEntry);
		}		 
	}
	//UnicodePref
	reminderFox_setUnicodePref("views", rmFxViewPrefs);

	window.close();
}

// =================================================
function rmFx_ViewButtons () {
}
		rmFx_ViewButtons.Start = function (vRemove) {
			rmFx_ViewButtons.View(false /*vAdd*/, vRemove /*vRemove*/);
			var xx   = reminderFox_getBundle().getString("rf.views.change");			
			rmFx_ViewButtons.Criteria (false /*listMode*/, true /*cMode*/, "" /*cValue*/, xx /*cLabel*/, false /*cDate*/,
						true /*cmAdd*/, true /*cmRemove*/);
		// OKbutton		
			document.getElementById('OK').removeAttribute("disabled");
		}
				
		rmFx_ViewButtons.CriteriaString = function (thisCritera, dateMode) {
			var edit   = reminderFox_getBundle().getString("rf.views.edit");
			rmFx_ViewButtons.View(true /*vAdd*/, true /*vRemove*/);
			rmFx_ViewButtons.Criteria (false /*listMode*/, false /*cMode*/, thisCritera /*cValue*/, edit /*cLabel*/, dateMode /*cDate*/,
						false /*cmAdd*/, false /*cmRemove*/);
		}
			
		rmFx_ViewButtons.CriteriaAdd = function () {
			var add   = reminderFox_getBundle().getString("rf.views.add");
			rmFx_ViewButtons.Criteria (false /*listMode*/, false /*cMode*/, "" /*cValue*/, add /*cLabel*/, false /*cDate*/,
						false /*cmAdd*/, false /*cmRemove*/);
			// OKbutton
			document.getElementById('OK').setAttribute("disabled","true");
		}
		
		rmFx_ViewButtons.CriteriaEnter = function () {
			rmFx_ViewButtons.View(false /*vAdd*/,  false /*vRemove*/);
			var xx   = reminderFox_getBundle().getString("rf.views.change");
			rmFx_ViewButtons.Criteria (false /*listMode*/, true /*cMode*/, "" /*cValue*/, xx /*cLabel*/, false /*cDate*/,
						false /*cmAdd*/, true /*cmRemove*/);
		// OKbutton		
			document.getElementById('OK').removeAttribute("disabled");
			}
		
		// --------------------------------
		rmFx_ViewButtons.View = function (vAdd, vRemove) {
		
			document.getElementById('view_Add').setAttribute("disabled", vAdd);	
			document.getElementById('view_Remove').setAttribute("disabled", vRemove);
		}
		
		rmFx_ViewButtons.Criteria = function (listMode, cMode, cValue, cLabel, dateMode,
					cmAdd, cmRemove) {
		
			document.getElementById('criteria_Add').setAttribute("disabled", cmAdd);
			document.getElementById('criteria_Remove').setAttribute("disabled", cmRemove);
			
			document.getElementById('criteria_List').setAttribute("disabled",listMode);
		
			document.getElementById('criteria_Typs').setAttribute("disabled",cMode);
			
			if (dateMode != "" ) {	// dateMode !
				document.getElementById('criteria_Box').setAttribute('hidden', true);	
				document.getElementById('criteria_Date').setAttribute('hidden', false)
				
				// select 'cValue' from pull down menu
				var criteriaDate = document.getElementById('criteria_Date')
				for (var i=0; i < criteriaDate.childNodes[0].childNodes.length; i++ ) { 
					if (dateMode == criteriaDate.childNodes[0].childNodes[i].label) {
							criteriaDate.selectedIndex = i;
					}
				}

			} else {  // stringMode 
				document.getElementById('criteria_Date').setAttribute('hidden', true);	
				document.getElementById('criteria_Box').setAttribute('hidden', false)

				document.getElementById('criteria_Box').value = cValue; 
			}			
			
			document.getElementById('criteria_Mode').setAttribute("disabled",cMode);
			document.getElementById('criteria_Mode').label= cLabel;
		}


// -------------------------------------------------		
function rmFx_ExportCurrentView() {
	
	var reminders = new Array();
	var reminderFoxTodosArrayArg;
	var reminderTyp;
	var selectedTyp = 'info';

	// get reminders and todos model from the list window if possible - this allows you to get the latest categories even if not yet saved to 
	// the ics file yet
	
	// on 'reminders' or 'List/Todos' ??
	
	if (isReminderTabSelected() || isSubscribedCalendarTabSelected()){	
		reminderTyp = 'reminder';
		
		var currentReminders = getCurrentReminderList();
	
		var treeChildren = document.getElementById("treechildren");

		var x = 0;
		
		for ( var item = 0; item < treeChildren.childNodes.length; item++ ) {	
	      var selectedTreeItem = treeChildren.childNodes[item];
	      var id = selectedTreeItem.childNodes[0].getAttribute(REMINDER_ID_REF);    
			
			for (var j=0; j < currentReminders.length; j++) {
				
				if ( currentReminders[j].id == id ) {
					reminders[x] = reminderFox_cloneReminderFoxEvent(currentReminders[j]);
					
					if (reminders[x].categories == null) {
						reminders[x].categories = rmFxViewLabel;
					} else {
						reminders[x].categories += "," + rmFxViewLabel;
					}
					x++;
				}
			}
		}
	} else {
		reminderTyp = 'todo';
		
		var tab =    document.getElementById("tabList").selectedItem;
		var listName = tab.getAttribute( "label");
		
		reminderFoxTodosArrayArg =  rmFxGetallTodos();
	//	reminderFoxTodosArrayArg =  reminderFoxListWindow.reminderFox_getReminderTodos();
	//	reminders[0] = rmFx_check4ViewedEvents(reminderFoxTodosArrayArg[listName], reminderTyp); 

		var selectedEvents = new Array();
		var j=0;		
	  	for ( var n in reminderFoxTodosArrayArg[listName] ) {
			if (rmFx_ViewThis(reminderFoxTodosArrayArg[listName][n])) {

			  	selectedEvents[j] = reminderFox_cloneReminderFoxTodo(reminderFoxTodosArrayArg[listName][n]);	

				if (selectedEvents[j].extraInfo == null) {
					selectedEvents[j].extraInfo = REMINDERFOX_EXTENDED + "LISTID:" + listName;
				} else {
					if (selectedEvents[j].extraInfo.indexOf(REMINDERFOX_EXTENDED + "LISTID") == -1) {
						selectedEvents[j].extraInfo += "\\n" + REMINDERFOX_EXTENDED + "LISTID:" + listName;
					}
				}

				
				if (selectedEvents[j].categories == null) {
					selectedEvents[j].categories = rmFxViewLabel;
				} else {
					selectedEvents[j].categories += "," + rmFxViewLabel;
				}		
				j++;
			}
	  	} 
	  	reminders[0] = selectedEvents;
	}
	
	rmFx_ExportOrSend (null, 'info' /*selectedTyp*/, reminderTyp, reminders)
}

function rmFx_check4ViewedEvents(events, reminderTyp) {
	var selectedEvents = new Array();
	var j=0;		
  	for ( var n in events ) {
		if (rmFx_ViewThis(events[n])) {
			if (reminderTyp == 'todo') {
		  		selectedEvents[j] = reminderFox_cloneReminderFoxTodo(events[n]);	
			} else {
		  		selectedEvents[j] = reminderFox_cloneReminderFoxEvent(events[n]);					
			}

	//gW 2009-11-17		
			if (selectedEvents[j].extraInfo == null) {
				selectedEvents[j].extraInfo = REMINDERFOX_EXTENDED + "LISTID:" + tabLabel;
			} else {
				if (selectedEvents[j].extraInfo.indexOf(REMINDERFOX_EXTENDED + "LISTID") == -1) {
					selectedEvents[j].extraInfo += "\\n" + REMINDERFOX_EXTENDED + "LISTID:" + tabLabel;
				}
			}

			
			if (selectedEvents[j].categories == null) {
				selectedEvents[j].categories = rmFxViewLabel;
			} else {
				selectedEvents[j].categories += "," + rmFxViewLabel;
			}		
			j++;
		}
  	} 
	return selectedEvents;
}	
	
	//reminderFox: Retrieving subscribed calendar: http://dl.erweiterungen.de/kalenderdateien/Feiertage_2006-2010_DE.ics


function rmFxGetallTodos() {
	var reminders;
	var reminderFoxTodosArrayArg;
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var reminderFoxListWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxEdit");	 

	 if (reminderFoxListWindow) {
	 	reminders = reminderFoxListWindow.reminderFox_getReminderEvents();
	 	reminderFoxTodosArrayArg =  reminderFoxListWindow.reminderFox_getReminderTodos();
	 }
	 else {
	 	reminders = reminderFox_getReminderEvents();
	 	reminderFoxTodosArrayArg =  reminderFox_getReminderTodos();
	 }
	 return reminderFoxTodosArrayArg;
}